Index: main/plugin-forms/resources/js/org/ametys/forms/workflow/FurtherInformationDialog.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/workflow/FurtherInformationDialog.i18n.js	(revision 0)
+++ main/plugin-forms/resources/js/org/ametys/forms/workflow/FurtherInformationDialog.i18n.js	(revision 0)
@@ -0,0 +1,209 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+Ext.namespace('org.ametys.plugins.forms.workflow');
+
+/**
+ * Create the further information dialog box.
+ */
+org.ametys.plugins.forms.workflow.FurtherInformationDialog = function(formId, item, comment, callback)
+{
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._callback = callback;
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._formId = formId;
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._item = item;
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._comment = comment;
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._initialize();
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._form.getForm().reset();
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._setValues(item.entryIds[0]);
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._box.show();
+}
+
+org.ametys.plugins.forms.workflow.FurtherInformationDialog._initialize = function()
+{
+	if (org.ametys.plugins.forms.workflow.FurtherInformationDialog._box != null)
+	{
+		return;
+	}
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldDoSend = new Ext.form.Checkbox ({
+		 fieldLabel: "<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_FIELD_DO_SEND"/>",
+		 name: "do-send",
+		 width: 285,
+		 allowBlank: false,
+		 listeners: {'check': org.ametys.plugins.forms.workflow.FurtherInformationDialog._onSendMailCheck},
+		 value: false
+	});
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldFrom= new Ext.form.TextField ({
+		 fieldLabel: "<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_FIELD_FROM_FULLNAME"/>",
+		 name: "from-fullname",
+		 width: 285,
+		 allowBlank: false,
+		 value: "",
+		 disabled: true
+	});
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldTo = new Ext.form.ComboBox ({
+		 fieldLabel: "<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_FIELD_TO"/>",
+		 name: "to",
+		 width: 285,
+		 mode: 'local',
+		 forceSelection : true,
+		 triggerAction: 'all',		
+		 editable: false,
+		 valueField: 'id',
+ 		 displayField: 'text',
+ 		 disabled: true,
+ 		 allowBlank: false,
+		 
+		 store: new Ext.data.ArrayStore({
+	        fields: [
+	            'id',
+	            'text'
+	        ],
+	        data: []
+		 }),
+		 value: ""
+	});
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldSubject = new Ext.form.TextField ({
+		 fieldLabel: "<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_FIELD_SUBJECT"/>",
+		 name: "subject",
+		 width: 285,
+		 allowBlank: false,
+		 disabled: true,
+		 value: ""
+	});
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldBody = new Ext.form.TextArea ({
+		 fieldLabel: "<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_FIELD_BODY"/>",
+		 name: "body",
+		 width: 285,
+		 allowBlank: false,
+		 height: 200,
+		 disabled: true,
+		 value: ""
+	});
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._form = new Ext.FormPanel( {
+		formId : 'further-info-form',
+		labelWidth: 90,
+		border: false,
+		items: [ org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldDoSend,
+		         org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldFrom,
+		         org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldTo, 
+		         org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldSubject, 
+		         org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldBody ]
+	});
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._box = new org.ametys.DialogBox ({
+		title: "<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_TITLE"/>",
+		icon: getPluginResourcesUrl("forms") + "/img/edition/mailreceipt_16.png",
+
+		cls: 'text-dialog',
+		width: 425,
+		height: 400,
+		
+		items: [ org.ametys.plugins.forms.workflow.FurtherInformationDialog._form ],
+			
+		closeAction: 'hide',
+		defaultButton: org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldBody,
+		buttons : [ 
+		    {
+				text : "<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_OK"/>",
+				handler: org.ametys.plugins.forms.workflow.FurtherInformationDialog._ok
+		    }, 
+		    {
+				text : "<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_CANCEL"/>",
+				handler: org.ametys.plugins.forms.workflow.FurtherInformationDialog._cancel
+		    }
+		]
+	});
+}
+
+org.ametys.plugins.forms.workflow.FurtherInformationDialog._setValues = function()
+{
+	var entryId = org.ametys.plugins.forms.workflow.FurtherInformationDialog._item.entryIds[0];
+	var formId = org.ametys.plugins.forms.workflow.FurtherInformationDialog._formId;
+	
+	// Server call
+	var serverMessage = new org.ametys.servercomm.ServerMessage('forms', 'further-information', {formId: formId, entryId: entryId}, org.ametys.servercomm.ServerComm.PRIORITY_MAJOR, org.ametys.plugins.forms.workflow.FurtherInformationDialog._setValuesCb, this, null);
+	org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
+}
+
+org.ametys.plugins.forms.workflow.FurtherInformationDialog._setValuesCb = function(response, args)
+{
+	var furtherInfo = response.selectSingleNode("further-information");
+
+	var currentUser = furtherInfo.selectSingleNode("current-user");
+	var currentUserFullName = currentUser.getAttribute("fullname");
+	
+	var senderStandardizedName = currentUserFullName + " &lt;" + currentUser.getAttribute("email") + "&gt;";
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldFrom.setValue(senderStandardizedName);
+	
+	var emails = furtherInfo.selectSingleNode("emails").selectNodes("email");
+
+	var emailsInfo = [];
+	Ext.each(emails, function(emailNode) {
+		emailsInfo.push([emailNode.getAttribute("value"), emailNode.getAttribute("displayValue")]);
+	});
+	
+	var hasEmails = !Ext.isEmpty(emailsInfo);
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldDoSend.setValue(hasEmails);
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldTo.getStore().removeAll();
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldTo.getStore().loadData(emailsInfo);
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldTo.setValue(hasEmails ? emailsInfo[0][0] : null);
+	
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldSubject.setValue("<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_SUBJECT_DEFAULT"/>");
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldBody.setValue("<i18n:text i18n:key="PLUGINS_FORMS_NEED_COMPLEMENTS_DIALOG_BODY_DEFAULT"/>" + currentUserFullName);
+}
+
+org.ametys.plugins.forms.workflow.FurtherInformationDialog._onSendMailCheck = function (field, checked)
+{
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldTo.setDisabled(!checked);
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldSubject.setDisabled(!checked);
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldBody.setDisabled(!checked);
+}
+
+org.ametys.plugins.forms.workflow.FurtherInformationDialog._ok = function()
+{
+	if (org.ametys.plugins.forms.workflow.FurtherInformationDialog._form.getForm().isValid())																									
+	{
+		var values = {};
+
+		var sendMail = org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldDoSend.getValue();
+		if (sendMail)
+		{
+			values.recipient = org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldTo.getValue();
+			values.subject = org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldSubject.getValue();
+			values.body = org.ametys.plugins.forms.workflow.FurtherInformationDialog._fieldBody.getValue();
+		}
+		
+		org.ametys.plugins.forms.workflow.FurtherInformationDialog._box.hide();
+		
+		org.ametys.plugins.forms.workflow.FurtherInformationDialog._callback(
+			org.ametys.plugins.forms.workflow.FurtherInformationDialog._formId,
+			org.ametys.plugins.forms.workflow.FurtherInformationDialog._item,
+			org.ametys.plugins.forms.workflow.FurtherInformationDialog._comment,
+			values
+		);
+	}
+}
+
+org.ametys.plugins.forms.workflow.FurtherInformationDialog._cancel = function()
+{
+	org.ametys.plugins.forms.workflow.FurtherInformationDialog._box.hide();
+}
\ No newline at end of file
Index: main/plugin-forms/sitemap.xmap
===================================================================
--- main/plugin-forms/sitemap.xmap	(revision 40266)
+++ main/plugin-forms/sitemap.xmap	(working copy)
@@ -29,6 +29,9 @@
             <map:generator name="forms-list" src="org.ametys.plugins.forms.data.FormsListGenerator" logger="org.ametys.plugins.forms.data.FormsListGenerator"/>
         
             <map:generator name="administrator-orphan-forms" src="org.ametys.plugins.forms.OrphanFormsGenerator" logger="org.ametys.plugins.forms.OrphanFormsGenerator"/>
+            
+            <map:generator name="form-workflows-ribbon" src="org.ametys.plugins.forms.workflow.FormEntriesWorkflowsGenerator" logger="org.ametys.plugins.forms.workflow.FormEntriesWorkflowsGenerator"/>
+            <map:generator name="further-info" src="org.ametys.plugins.forms.workflow.FurtherInformationGenerator" logger="org.ametys.plugins.forms.workflow.FurtherInformationGenerator"/>
         </map:generators>
         
         <map:actions>
@@ -42,6 +45,7 @@
             
             <map:action name="administrator-is-system-user" src="org.ametys.runtime.plugins.core.right.actions.IsAdminAction" logger="org.ametys.runtime.plugins.web.administrator.sitemap.action.isAdmin"/>
             <map:action name="delete-form" src="org.ametys.plugins.forms.DeleteFormTableAction" logger="org.ametys.plugins.forms.DeleteFormTableAction"/>
+            <map:action name="do-action" src="org.ametys.plugins.forms.workflow.FormEntriesWorkflowAction" logger="org.ametys.plugins.forms.workflow.FormEntriesWorkflowAction"/>
         </map:actions>
         
         <map:serializers>
@@ -70,6 +74,10 @@
                 <map:generate type="content-forms"/>
                 <map:serialize type="xml"/>
             </map:match>
+            <map:match pattern="ribbon-part">
+                <map:generate type="form-workflows-ribbon"/>
+                <map:serialize type="xml"/>
+            </map:match>
         </map:pipeline>
         
 		<map:pipeline>
@@ -241,6 +249,39 @@
                 <map:serialize type="xml"/>
             </map:match>
             
+            <map:match pattern="further-information">
+                <map:generate type="further-info"/>
+                <map:serialize type="xml"/>    
+            </map:match>
+            
+            <map:match pattern="do-action/*">
+                <map:act type="do-action">
+                    <map:parameter name="actionId" value="{1}"/>
+                    <map:parameter name="entryId" value="{parent-context-attr:entryId}"/>
+                    <map:parameter name="formId" value="{parent-context-attr:formId}"/>
+                    <map:parameter name="furtherInfo" value="{parent-context-attr:furtherInfo}"/>
+                </map:act>
+                <map:generate type="action-result"/>
+                <map:serialize type="xml" status-code="500"/>
+            </map:match>
+            
+            <map:match pattern="resources_workflow/**">
+                <map:read src="context://WEB-INF/param/workflow_resources/{1}"/>
+            </map:match>
+            
+            <map:match pattern="ribbon.xml">
+                <map:aggregate element="root" label="xml">
+                    <map:part src="cms-ribbon.xml"/>
+                    <map:part src="cocoon:/ribbon-part"/>
+                </map:aggregate>
+                <map:transform type="xslt" src="stylesheets/ribbon/ribbon.xsl" />
+                <map:transform type="i18n">
+                    <map:parameter name="locale" value="{locale:locale}"/>
+                    <map:parameter name="plugin" value="{request-attr:pluginName}"/>
+                </map:transform>
+                <map:serialize type="xml"/>
+            </map:match>
+            
             <!-- ********************* ADMIN ************************* -->
             <map:match pattern="administrator/**">
                 <map:act type="administrator-is-system-user"/>
Index: main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormEntriesAction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormEntriesAction.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormEntriesAction.java	(working copy)
@@ -15,6 +15,7 @@
  */
 package org.ametys.plugins.forms;
 
+import java.util.ArrayList;
 import java.util.List;
 import java.util.Map;
 
@@ -29,23 +30,24 @@
 import org.apache.commons.collections.CollectionUtils;
 import org.apache.commons.lang.StringUtils;
 
-import org.ametys.plugins.forms.jcr.FormPropertiesManager;
 import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.plugins.forms.workflow.FormEntriesWorkflow;
+import org.ametys.plugins.workflow.store.JdbcWorkflowStore;
 
 /**
  * Action for deleting one, multiple or all entries for a form.
  */
 public class DeleteFormEntriesAction extends ServiceableAction
 {
-    private FormPropertiesManager _formPropertiesManager;
     private FormTableManager _formTableManager;
+    private FormEntriesWorkflow _formEntriesWorkflow;
     
     @Override
     public void service(ServiceManager serviceManager) throws ServiceException
     {
         super.service(serviceManager);
-        _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE);
         _formTableManager = new FormTableManager();
+        _formEntriesWorkflow = (FormEntriesWorkflow) serviceManager.lookup(FormEntriesWorkflow.ROLE);
     }
     
     @SuppressWarnings("unchecked")
@@ -65,23 +67,29 @@
         
         for (String formId : formIds)
         {
-            Form form = _formPropertiesManager.getForm(siteName, formId);
-            if (form == null)
-            {
-                throw new ProcessingException("The form of ID '" + formId + " can't be found in the site '" + siteName + "'.");
-            }
-            
+            List<Integer> workflowIds = new ArrayList<Integer> (); 
+            List<Integer> entriesIds = (List<Integer>) jsParameters.get("ids");
             if (mode.equals("delete"))
             {
-                List<Integer> entriesIds = (List<Integer>) jsParameters.get("ids");
                 for (Integer entryId : entriesIds)
                 {
-                    _formTableManager.deleteSubmission(form, entryId);
+                    workflowIds.addAll(_formTableManager.getWorkflowIds(formId, entryId));
+                    _formTableManager.deleteSubmission(formId, entryId);
                 }
             }
             else if (mode.equals("clear"))
             {
-                _formTableManager.deleteSubmission(form, null);
+                workflowIds.addAll(_formTableManager.getWorkflowIds(formId, null));
+                _formTableManager.deleteSubmission(formId, null);
+            }
+            
+            // Delete the corresponding workflow instances and their history
+            JdbcWorkflowStore workflowStore = (JdbcWorkflowStore) _formEntriesWorkflow.getConfiguration().getWorkflowStore();
+            
+            for (Integer workflowId : workflowIds)
+            {
+                workflowStore.clearHistory(workflowId);
+                workflowStore.deleteInstance(workflowId);
             }
         }
         
Index: main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormTableAction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormTableAction.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormTableAction.java	(working copy)
@@ -1,53 +1,74 @@
 /*
- *  Copyright 2011 Anyware Services
+ * Copyright 2016 Anyware Services
  *
- *  Licensed under the Apache License, Version 2.0 (the "License");
- *  you may not use this file except in compliance with the License.
- *  You may obtain a copy of the License at
+ * Licensed under the Apache License, Version 2.0 (the "License"); you may not
+ * use this file except in compliance with the License. You may obtain a copy of
+ * the License at
  *
- *      http://www.apache.org/licenses/LICENSE-2.0
+ * http://www.apache.org/licenses/LICENSE-2.0
  *
- *  Unless required by applicable law or agreed to in writing, software
- *  distributed under the License is distributed on an "AS IS" BASIS,
- *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- *  See the License for the specific language governing permissions and
- *  limitations under the License.
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+ * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+ * License for the specific language governing permissions and limitations under
+ * the License.
  */
 package org.ametys.plugins.forms;
 
+import java.util.List;
 import java.util.Map;
 
 import org.apache.avalon.framework.activity.Initializable;
 import org.apache.avalon.framework.parameters.Parameters;
-import org.apache.cocoon.acting.AbstractAction;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.acting.ServiceableAction;
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.SourceResolver;
 
 import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.plugins.forms.workflow.FormEntriesWorkflow;
+import org.ametys.plugins.workflow.store.JdbcWorkflowStore;
 
 /**
  * Delete a list of forms' tables
  */
-public class DeleteFormTableAction extends AbstractAction implements Initializable
+public class DeleteFormTableAction extends ServiceableAction implements Initializable
 {
     /** The manager for form SQL Tables */
     private FormTableManager _formTableManager;
     
+    /** The workflow component for form entries */
+    private FormEntriesWorkflow _formEntriesWorkflow;
+    
     @Override
     public void initialize() throws Exception
     {
         _formTableManager = new FormTableManager();
     }
     
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        _formEntriesWorkflow = (FormEntriesWorkflow) serviceManager.lookup(FormEntriesWorkflow.ROLE);
+    }
+    
     @SuppressWarnings("unchecked")
     public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
     {
         Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
         String tableName = (String) jsParameters.get("name");
         
-        _formTableManager.dropTable(tableName);
+        List<Integer> workflowIds = _formTableManager.getWorkflowIds(tableName.substring(FormTableManager.TABLE_PREFIX.length()), null);
+        JdbcWorkflowStore workflowStore = (JdbcWorkflowStore) _formEntriesWorkflow.getConfiguration().getWorkflowStore();
+        for (Integer workflowId : workflowIds)
+        {
+            workflowStore.clearHistory(workflowId);
+            workflowStore.deleteInstance(workflowId);
+        }
         
+        _formTableManager.dropTable(tableName);
         return EMPTY_MAP;
     }
 }
Index: main/plugin-forms/src/org/ametys/plugins/forms/Form.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/Form.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/Form.java	(working copy)
@@ -28,13 +28,10 @@
  */
 public class Form
 {
-    
     /** The form id. */
     protected String _id;
-    
     /** The form label. */
     protected String _label;
-    
     /** The field which indicates the email to send an acknowledgement of receipt. */
     protected String _receiptFieldId;
     /** The email address of the sender. Can be empty to use default one. */
@@ -45,7 +42,9 @@
     protected String _receiptFieldBody;
     /** The id of the page where to redirect to. Can be empty */
     protected String _redirectTo;
-
+    /** The workflow of this form's submissions */
+    protected String _workflowName;
+    
     /** The form emails. */
     protected Set<String> _notificationEmails;
     
@@ -63,7 +62,7 @@
      */
     public Form()
     {
-        this("", "", "", "", "", "", new HashSet<String>(), "", new ArrayList<Field>(), new ArrayList<Fieldset>(), "");
+        this("", "", "", "", "", "", new HashSet<String>(), "", new ArrayList<Field>(), new ArrayList<Fieldset>(), "", "");
     }
     
     /**
@@ -80,7 +79,7 @@
      * @param fieldsets the form fieldsets.
      * @param redirectTo the id of the page where to redirect to
      */
-    public Form(String id, String label, String receiptFieldId, String receiptFieldFromAddress, String receiptFieldSubject, String receiptFieldBody, Set<String> emails, String contentId, Collection<Field> fields, Collection<Fieldset> fieldsets, String redirectTo)
+    public Form(String id, String label, String receiptFieldId, String receiptFieldFromAddress, String receiptFieldSubject, String receiptFieldBody, Set<String> emails, String contentId, Collection<Field> fields, Collection<Fieldset> fieldsets, String redirectTo, String workflowName)
     {
         this._id = id;
         this._label = label;
@@ -93,6 +92,7 @@
         this._fields = new ArrayList<Field>(fields);
         this._fieldsets = new ArrayList<Fieldset>(fieldsets);
         this._redirectTo = redirectTo;
+        this._workflowName = workflowName;
     }
 
     /**
@@ -306,4 +306,22 @@
     {
         _redirectTo = redirectTo;
     }
+    
+    /**
+     * Retrieve the name of the workflow of this form's entries
+     * @return the name of the workflow used
+     */
+    public String getWorkflowName()
+    {
+        return _workflowName;
+    }
+    
+    /**
+     * Set the name of the workflow of this form's entries
+     * @param workflowName the name of the workflow to use
+     */
+    public void setWorkflowName(String workflowName)
+    {
+        _workflowName = workflowName;
+    }
 }
Index: main/plugin-forms/src/org/ametys/plugins/forms/FormManager.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/FormManager.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/FormManager.java	(working copy)
@@ -18,8 +18,10 @@
 import java.io.IOException;
 import java.io.InputStream;
 import java.util.ArrayList;
+import java.util.Collections;
 import java.util.HashSet;
 import java.util.List;
+import java.util.Map;
 import java.util.Set;
 
 import org.apache.avalon.framework.activity.Initializable;
@@ -37,13 +39,20 @@
 import org.xml.sax.SAXException;
 
 import org.ametys.cms.repository.Content;
+import org.ametys.plugins.forms.data.FieldValue;
+import org.ametys.plugins.forms.data.UserEntry;
 import org.ametys.plugins.forms.jcr.FormPropertiesManager;
 import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.plugins.forms.workflow.FormEntriesWorkflow;
 import org.ametys.plugins.forms.workflow.FormParser;
 import org.ametys.plugins.repository.metadata.CompositeMetadata;
 import org.ametys.plugins.repository.metadata.RichText;
+import org.ametys.plugins.workflow.store.JdbcWorkflowStore;
 import org.ametys.web.repository.content.WebContent;
 
+import com.opensymphony.workflow.StoreException;
+import com.opensymphony.workflow.WorkflowException;
+
 /**
  * Class to handle forms in contents
  */
@@ -58,6 +67,7 @@
     private DOMParser _parser;
     private FormParser _formParser;
     private FormTableManager _formTableManager;
+    private FormEntriesWorkflow _formEntriesWorkflow;
     
     @Override
     public void service(ServiceManager smanager) throws ServiceException
@@ -66,6 +76,7 @@
         XPathProcessor processor = (XPathProcessor) smanager.lookup(XPathProcessor.ROLE);
         _formParser = new FormParser(processor);
         _formPropertiesManager = (FormPropertiesManager) smanager.lookup(FormPropertiesManager.ROLE);
+        _formEntriesWorkflow = (FormEntriesWorkflow) smanager.lookup(FormEntriesWorkflow.ROLE);
     }
     
     @Override
@@ -79,8 +90,9 @@
      * @param content the content.
      * @throws SAXException if a SAX exception occurs during content parsing.
      * @throws IOException if an I/O exception occurs during content parsing.
+     * @throws WorkflowException if an exception occurs during the reset of the form entries workflow
      */
-    public void processContentForms(Content content) throws SAXException, IOException
+    public void processContentForms(Content content) throws SAXException, IOException, WorkflowException
     {
         String contentName = content.getName();
         String siteName = "";
@@ -109,13 +121,37 @@
             {
                 try
                 {
-                    // Parse the form node.
+                    // Parse the new form from the form node.
                     Form form = _formParser.parseForm(formNode);
                     forms.add(form);
-                    
-                    // Try to retrieve the old form properties from the repository.
+
                     Form oldForm = _formPropertiesManager.getForm(siteName, form.getId());
                     
+                    String newWorkflowName = StringUtils.defaultString(form.getWorkflowName());
+                    if (oldForm != null)
+                    {
+                        String oldWorkflowName = oldForm.getWorkflowName();
+                        if (!newWorkflowName.equals(StringUtils.defaultString(oldWorkflowName)))
+                        {
+                            // The workflow has switched
+                            boolean dropColumn = false;
+                            boolean addColumn = false;
+                            if (StringUtils.isEmpty(newWorkflowName) && _formTableManager.hasWorkflowIdColumn(form.getId()))
+                            {
+                                // from an existing workflow to no workflow
+                                dropColumn = true;
+                            }
+                            else if (!_formTableManager.hasWorkflowIdColumn(form.getId()))
+                            {
+                                // from no workflow to an existing workflow
+                                addColumn = true;
+                            }
+                            
+                            // update/delete the concerned tables
+                            _resetWorkflowTables(form, dropColumn, addColumn);
+                        }
+                    }
+                    
                     // TODO Give oldForm to the form table manager to compare old/new state (in particular for radio buttons.)
                     
                     // Create the table only if it was given a label.
@@ -145,7 +181,7 @@
             }
         }
         
-        removeUnusedForms(content, contentName, forms);
+        _removeUnusedForms(content, contentName, forms);
         
         if (getLogger().isDebugEnabled())
         {
@@ -154,12 +190,62 @@
     }
     
     /**
+     * Remove the workflow tables and the workflow id column if needed
+     * @param form the form 
+     * @param dropColumn true to drop the workflow id column
+     * @throws FormsException if an error occurs while retrieving the workflow instances ids 
+     * @throws WorkflowException if an error occurs during the reset of the workflow of the form entries 
+     */
+    private void _resetWorkflowTables(Form form, boolean dropColumn, boolean addColumn) throws FormsException, WorkflowException
+    {
+        Map<String, FieldValue> columns = _formTableManager.getColumns(form);
+        List<UserEntry> submissions = _formTableManager.getSubmissions(form, columns, 0, Integer.MAX_VALUE, null);
+        try
+        {
+            // Add the column just now to get the proper submissions
+            if (addColumn)
+            {
+                _formTableManager.addWorkflowIdColumn(form.getId());
+            }
+            
+            // Delete the corresponding workflow instances and their history
+            JdbcWorkflowStore workflowStore = (JdbcWorkflowStore) _formEntriesWorkflow.getConfiguration().getWorkflowStore();
+            for (UserEntry submission : submissions)
+            {
+                Integer workflowId = submission.getWorkflowId();
+                if (workflowId != null)
+                {
+                    workflowStore.clearHistory(workflowId);
+                    workflowStore.deleteInstance(workflowId);
+                }
+
+                if (!dropColumn)
+                {
+                    String workflowName = form.getWorkflowName();
+                    int initialActionId = _formEntriesWorkflow.getInitialAction(workflowName);
+                    long newWorkflowId = _formEntriesWorkflow.initialize(workflowName, initialActionId, Collections.EMPTY_MAP);
+                    _formTableManager.setWorkflowId(form, submission.getId(), newWorkflowId);
+                }
+            }
+            
+            if (dropColumn)
+            {
+                _formTableManager.dropWorkflowIdColumn(form.getId());
+            }
+        }
+        catch (StoreException e)
+        {
+            getLogger().error("Unable to retrieve the workflow store", e);
+        }
+    }   
+
+    /**
      * Remove the unused forms
      * @param content The content
      * @param contentName The name of the content
      * @param forms The forms submitted
      */
-    public void removeUnusedForms(Content content, String contentName, List<Form> forms)
+    private void _removeUnusedForms(Content content, String contentName, List<Form> forms)
     {
         try
         {
